#pragma once
#include "MedialAxisDefines.h"
#include "PoroMediaDialogShare.h"
#include "DirectoryBrowser.h"
#include "MedialInput.h"
#include "afxwin.h"


// MedialDialog dialog

class MedialDialog : public CDialog, public PoroMediaDialogShare
{
	DECLARE_DYNAMIC(MedialDialog)

public:
	MedialDialog(CWnd* pParent = NULL);   // standard constructor
	virtual ~MedialDialog();

// Dialog Data
	enum { IDD = IDD_MEDIALDIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnOK();
	virtual void OnCancel();
	virtual BOOL OnInitDialog();

	// General
	afx_msg void OnBnClickedButtonInputDirectory();
	afx_msg void OnBnClickedButtonWorkDirectory();
	afx_msg void OnCbnSelchangeComboThresholdingMethod();
	afx_msg void OnBnClickedStop();
	afx_msg void OnEnChangeEditWidthSlices();
	afx_msg void OnEnChangeEditEndSlice();
	afx_msg void OnEnChangeEditWidthx();
	afx_msg void OnEnChangeEditEndx();
	afx_msg void OnEnChangeEditWidthy();
	afx_msg void OnEnChangeEditEndy();
	afx_msg void OnEnChangeEditStartSlice();
	afx_msg void OnEnChangeEditStartx();
	afx_msg void OnEnChangeEditStarty();
	afx_msg void OnEnChangeEditManualThreshold();

	DECLARE_MESSAGE_MAP()

public:
	// Saving
	CButton check_save_bs_cube;
	CButton check_save_ss_cube;
	CButton check_save_cl_cube;
	CButton check_save_bs_cube_rgb;
	CButton check_save_ss_cube_rgb;
	CButton check_save_cl_cube_rgb;
	CButton check_mark_cl_max;
	CButton check_save_sp_cube;
	CButton check_save_medial_axis_1bit;
	CButton check_save_medial_axis_detailed;
	CButton check_save_medial_axis_graph;
	CButton check_network_graph_txt;

	// Options
	CButton check_bounds_are_fiber;
	CComboBox combo_rp_method;
	CButton check_run_on_fiber;
	CButton check_log_deleted_paths;
	CButton check_log_forced_links;
	CButton check_enable_caching_from_disc;

	CEdit	field_cache_ram_limit_cntrl;
	int		field_cache_ram_limit_int;

	// Analysis
	CEdit	field_node_dens_um_cube_cntrl;
	float	field_node_dens_um_cube_float;

	// Optional inputs
	CButton check_bs_input;
	CButton check_ss_input;
	CButton check_cl_input;
	CButton check_ma_input;
	CButton button_bs_cube;
	CButton button_ss_cube;
	CButton button_cl_cube;
	CButton button_ma_cube;
	CEdit	field_bs_file_name_cntrl;
	CEdit	field_ss_file_name_cntrl;
	CEdit	field_cl_file_name_cntrl;
	CEdit	field_ma_file_name_cntrl;
	char	input_bs_cube_file_name[MAX_FILE_STR_LEN];
	char	input_ss_cube_file_name[MAX_FILE_STR_LEN];
	char	input_cl_cube_file_name[MAX_FILE_STR_LEN];
	char	input_ma_cube_file_name[MAX_FILE_STR_LEN];
	bool	is_bs_input_valid;
	bool	is_ss_input_valid;
	bool	is_cl_input_valid;
	bool	is_ma_input_valid;


	afx_msg void OnBnClickedButtonBsCubeInput();
	afx_msg void OnBnClickedButtonSsCubeInput();
	afx_msg void OnBnClickedButtonClCubeInput();
	afx_msg void OnBnClickedButtonFinalMaInput();
	afx_msg void OnBnClickedCheckBsInput();
	afx_msg void OnBnClickedCheckSsInput();
	afx_msg void OnBnClickedCheckClInput();
	afx_msg void OnBnClickedCheckSaveMaInput();
	afx_msg void OnBnClickedCheckEnableCaching();
};
